diff --git a/src/common/SurgeStorage.cpp b/src/common/SurgeStorage.cpp
index 295f7967755..5f6fbc6a432 100644
--- a/src/common/SurgeStorage.cpp
+++ b/src/common/SurgeStorage.cpp
@@ -31,6 +31,8 @@
 #include <iomanip>
 #include <sstream>
 
+#include "UserDefaults.h"
+
 
 float sinctable alignas(16)[(FIRipol_M + 1) * FIRipol_N * 2];
 float sinctable1X alignas(16)[(FIRipol_M + 1) * FIRipol_N];
@@ -243,6 +245,15 @@ SurgeStorage::SurgeStorage(std::string suppliedDataPath)
 #endif
 #endif
 
+   userDefaultFilePath = userDataPath;
+   
+   std::string userSpecifiedDataPath = Surge::Storage::getUserDefaultValue(this, "userDataPath", "UNSPEC" );
+   if( userSpecifiedDataPath != "UNSPEC" )
+   {
+       std::cout << "Got a custom user data path" << std::endl;
+       userDataPath = userSpecifiedDataPath;
+   }
+   
 #if LINUX
    if (!snapshotloader.Parse((const char*)&configurationXmlStart, 0,
                              TIXML_ENCODING_UTF8)) {
diff --git a/src/common/SurgeStorage.h b/src/common/SurgeStorage.h
index 369f585b91e..1db84788f73 100644
--- a/src/common/SurgeStorage.h
+++ b/src/common/SurgeStorage.h
@@ -547,6 +547,8 @@ class alignas(16) SurgeStorage
    std::string wtpath;
    std::string datapath;
    std::string userDataPath;
+   std::string userDefaultFilePath;
+   
    std::string defaultsig, defaultname;
    // float table_sin[512],table_sin_offset[512];
    Surge::CriticalSection CS_WaveTableData, CS_ModRouting;
diff --git a/src/common/UserDefaults.cpp b/src/common/UserDefaults.cpp
index 32888e82b07..269a02c565d 100644
--- a/src/common/UserDefaults.cpp
+++ b/src/common/UserDefaults.cpp
@@ -45,7 +45,7 @@ bool haveReadDefaultsFile = false;
 
 std::string defaultsFileName(SurgeStorage *storage)
 {
-    std::string fn = storage->userDataPath + "/SurgeUserDefaults.xml";
+    std::string fn = storage->userDefaultFilePath + "/SurgeUserDefaults.xml";
     return fn;
 }
 
@@ -99,7 +99,7 @@ bool storeUserDefaultValue(SurgeStorage *storage, const std::string &key, const
     ** See SurgeSytnehsizer::savePatch for instance
     ** and so we have to do the same here
     */
-    fs::create_directories(storage->userDataPath);
+    fs::create_directories(storage->userDefaultFilePath);
 
     
     UserDefaultValue v;
diff --git a/src/common/UserDefaults.h b/src/common/UserDefaults.h
index b4b138a8fdf..371e9ea81e8 100644
--- a/src/common/UserDefaults.h
+++ b/src/common/UserDefaults.h
@@ -12,6 +12,7 @@
 ** persist this information.
 */
 
+
 namespace Surge
 {
 namespace Storage
diff --git a/src/common/UserInteractions.h b/src/common/UserInteractions.h
index e456187dd7b..62795e53a61 100644
--- a/src/common/UserInteractions.h
+++ b/src/common/UserInteractions.h
@@ -53,6 +53,8 @@ void openFolderInFileBrowser(const std::string& folder);
 void promptFileOpenDialog(const std::string& initialDirectory,
                           const std::string& filterSuffix,
                           std::function<void(std::string)> callbackOnOpen,
+                          bool canSelectDirectories = false,
+                          bool canCreateDirectories = false,
                           SurgeGUIEditor* guiEditor = nullptr);
 };
 
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index c99908b09be..ebb0b7ebe42 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -2862,7 +2862,23 @@ void SurgeGUIEditor::showSettingsMenu(CRect &menuRect)
        this->synth->storage.refresh_wtlist();
        this->synth->storage.refresh_patchlist();
     });
+    did++;
 
+    addCallbackMenu( dataSubMenu, "Set Custom User Data Folder", [this]() {
+            auto cb = [this](std::string f) {
+                // FIXME - check if f is a path
+                this->synth->storage.userDataPath = f;
+                Surge::Storage::updateUserDefaultValue(&(this->synth->storage),
+                                                       "userDataPath",
+                                                       f);
+                this->synth->storage.refresh_wtlist();
+                this->synth->storage.refresh_patchlist();
+            };
+            Surge::UserInteractions::promptFileOpenDialog("", "", cb, true, true);
+                                                          
+        });
+    did++;
+    
     settingsMenu->addEntry( dataSubMenu, "Data and Patches");
     eid++;
     dataSubMenu->forget();
diff --git a/src/headless/UserInteractionsHeadless.cpp b/src/headless/UserInteractionsHeadless.cpp
index a18dcd67353..11b0422061a 100644
--- a/src/headless/UserInteractionsHeadless.cpp
+++ b/src/headless/UserInteractionsHeadless.cpp
@@ -37,6 +37,7 @@ void openURL(const std::string &url)
 void promptFileOpenDialog(const std::string& initialDirectory,
                           const std::string& filterSuffix,
                           std::function<void(std::string)> callbackOnOpen,
+			  bool od, bool cd,
                           SurgeGUIEditor* guiEditor)
 {
    UserInteractions::promptError("OpenFileDialog is unimplemented in this version of Surge. Sorry!",
diff --git a/src/linux/UserInteractionsLinux.cpp b/src/linux/UserInteractionsLinux.cpp
index fa109a4766d..2454db27642 100644
--- a/src/linux/UserInteractionsLinux.cpp
+++ b/src/linux/UserInteractionsLinux.cpp
@@ -75,6 +75,8 @@ void openFolderInFileBrowser(const std::string& folder)
 void promptFileOpenDialog(const std::string& initialDirectory,
                           const std::string& filterSuffix,
                           std::function<void(std::string)> callbackOnOpen,
+                          bool canSelectDirectories,
+                          bool canCreateDirectories,
                           SurgeGUIEditor* guiEditor)
 {
    /*
diff --git a/src/mac/UserInteractionsMac.mm b/src/mac/UserInteractionsMac.mm
index f9c7faa74d3..6fa0a8fe2d9 100644
--- a/src/mac/UserInteractionsMac.mm
+++ b/src/mac/UserInteractionsMac.mm
@@ -79,10 +79,14 @@ void openFolderInFileBrowser(const std::string& folder)
 void promptFileOpenDialog(const std::string& initialDirectory,
                           const std::string& filterSuffix,
                           std::function<void(std::string)> callbackOnOpen,
+                          bool canSelectDirectories,
+                          bool canCreateDirectories,
                           SurgeGUIEditor* guiEditor)
 {
    // FIXME TODO - support the filterSuffix and initialDirectory
    NSOpenPanel* panel = [NSOpenPanel openPanel];
+   [panel setCanChooseDirectories:canSelectDirectories];
+   [panel setCanCreateDirectories:canCreateDirectories]; 
 
    [panel beginWithCompletionHandler:^(NSInteger result) {
      if (result == NSFileHandlingPanelOKButton)
diff --git a/src/windows/UserInteractionsWin.cpp b/src/windows/UserInteractionsWin.cpp
index eef533b0860..6572be52166 100644
--- a/src/windows/UserInteractionsWin.cpp
+++ b/src/windows/UserInteractionsWin.cpp
@@ -1,6 +1,10 @@
-#include <Windows.h>
-#include <Commdlg.h>
+#include <windows.h>
+#include <shlobj.h>
+#include <commdlg.h>
 #include <string>
+#include <iostream>
+#include <sstream>
+
 #include "UserInteractions.h"
 #include "SurgeGUIEditor.h"
 
@@ -47,11 +51,68 @@ void openFolderInFileBrowser(const std::string& folder)
    UserInteractions::openURL(url);
 }
 
+// thanks https://stackoverflow.com/questions/12034943/win32-select-directory-dialog-from-c-c  
+static int CALLBACK BrowseCallbackProc(HWND hwnd,UINT uMsg, LPARAM lParam, LPARAM lpData)
+{
+
+    if(uMsg == BFFM_INITIALIZED)
+    {
+        std::string tmp = (const char *) lpData;
+        std::cout << "path: " << tmp << std::endl;
+        SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
+    }
+
+    return 0;
+}
+
+std::string BrowseFolder(std::string saved_path)
+{
+    TCHAR path[MAX_PATH];
+
+    const char * path_param = saved_path.c_str();
+
+    BROWSEINFO bi = { 0 };
+    bi.lpszTitle  = ("Browse for folder...");
+    bi.ulFlags    = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE;
+    bi.lpfn       = BrowseCallbackProc;
+    bi.lParam     = (LPARAM) path_param;
+
+    LPITEMIDLIST pidl = SHBrowseForFolder ( &bi );
+
+    if ( pidl != 0 )
+    {
+        //get the name of the folder and put it in path
+        SHGetPathFromIDList ( pidl, path );
+
+        //free memory used
+        IMalloc * imalloc = 0;
+        if ( SUCCEEDED( SHGetMalloc ( &imalloc )) )
+        {
+            imalloc->Free ( pidl );
+            imalloc->Release ( );
+        }
+
+        return path;
+    }
+
+    return "";
+}
+
+
+  
 void promptFileOpenDialog(const std::string& initialDirectory,
                           const std::string& filterSuffix,
                           std::function<void(std::string)> callbackOnOpen,
+                          bool canSelectDirectories,
+                          bool canCreateDirectories,
                           SurgeGUIEditor* guiEditor)
 {
+  if( canSelectDirectories )
+    {
+      auto s = BrowseFolder( "c:" );
+      callbackOnOpen(s);
+      return;
+    }
    // With many thanks to
    // https://www.daniweb.com/programming/software-development/code/217307/a-simple-getopenfilename-example
    char szFile[1024];
